VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrRotate 
      Interval        =   100
      Left            =   1920
      Top             =   2040
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PI As Single = 3.14159265
Private Const DALPHA As Single = PI / 6
Private m_Alpha As Single
Private Sub CirclePoint(ByVal theta As Single, ByVal circle_radius As Single, ByRef x As Single, ByRef y As Single)
    x = circle_radius * Cos(theta)
    y = circle_radius * Sin(theta)
End Sub
Private Sub DrawEllipse(ByVal radius As Single, ByVal sx As Single, ByVal sy As Single, ByVal angle As Single, ByVal tx As Single, ByVal ty As Single, ByVal clr As OLE_COLOR)
Const DTHETA As Single = PI / 20
Dim x0 As Single
Dim y0 As Single
Dim x As Single
Dim y As Single
Dim theta As Single

    ' Get the first point.
    EllipsePoint x, y, 0, radius, sx, sy, angle, tx, ty
    CurrentX = x
    CurrentY = y
    x0 = x
    y0 = y

    ' Draw other points.
    For theta = DTHETA To 2 * PI Step DTHETA
        EllipsePoint x, y, theta, radius, sx, sy, angle, tx, ty
        Line -(x, y), clr
    Next theta

    ' Close the circle.
    Line -(x0, y0), clr
End Sub
Private Sub EllipsePoint(ByRef x As Single, ByRef y As Single, ByVal theta As Single, ByVal radius As Single, ByVal sx As Single, ByVal sy As Single, ByVal angle As Single, ByVal tx As Single, ByVal ty As Single)
    CirclePoint theta, radius, x, y
    ScalePoint sx, sy, x, y
    RotatePoint angle, x, y
    TranslatePoint tx, ty, x, y
End Sub
Private Sub RotatePoint(ByVal theta As Single, ByRef x As Single, ByRef y As Single)
Dim new_x As Single
Dim new_y As Single

    new_x = x * Cos(theta) + y * Sin(theta)
    new_y = x * Sin(theta) - y * Cos(theta)
    x = new_x
    y = new_y
End Sub
Private Sub ScalePoint(ByVal scale_x As Single, ByVal scale_y As Single, ByRef x As Single, ByRef y As Single)
    x = x * scale_x
    y = y * scale_y
End Sub
Private Sub TranslatePoint(ByVal tx As Single, ByVal ty As Single, ByRef x As Single, ByRef y As Single)
    x = x + tx
    y = y + ty
End Sub

Private Sub Form_Load()
    m_Alpha = 100
    Me.FillStyle = vbFSSolid
End Sub

Private Sub Form_Paint()
Const E_RADIUS As Single = 60
Dim cx As Single
Dim cy As Single
Dim x As Single
Dim y As Single

    Cls

    ' Draw the orbits and electrons.
    cx = 1440
    cy = 1440
    DrawEllipse 1440, 0.5, 0.15, PI / 3, cx, cy, vbRed
    EllipsePoint x, y, m_Alpha, 1440, 0.5, 0.15, PI / 3, cx, cy
    Me.FillColor = vbRed
    Me.Circle (x, y), E_RADIUS, vbRed

    DrawEllipse 1440, 0.5, 0.15, -PI / 3, cx, cy, vbRed
    EllipsePoint x, y, m_Alpha * 0.9, 1440, 0.5, 0.15, -PI / 3, cx, cy
    Me.FillColor = RGB(0, 128, 64)
    Me.Circle (x, y), E_RADIUS, RGB(0, 128, 64)

    DrawEllipse 1440, 0.5, 0.15, 0, cx, cy, vbRed
    EllipsePoint x, y, -m_Alpha * 0.8, 1440, 0.5, 0.15, 0, cx, cy
    Me.FillColor = vbBlue
    Me.Circle (x, y), E_RADIUS, vbBlue

    ' Draw the nucleus.
    Me.FillColor = vbBlack
    Me.Circle (cx, cy), 120, vbBlack

    ' Rotate a bit.
    m_Alpha = m_Alpha + DALPHA
End Sub
Private Sub tmrRotate_Timer()
    Form_Paint
End Sub
